local git_commit_message_group = vim.api.nvim_create_augroup('gitCommitMessage', { clear = true })
local plaintext = vim.api.nvim_create_augroup('plaintext', { clear = true })
local markdown = vim.api.nvim_create_augroup('markdown', { clear = true })
local yank_group = vim.api.nvim_create_augroup('HighlightYank', {})

vim.api.nvim_create_autocmd({'Filetype'}, {pattern = 'gitcommit', group = git_commit_message_group, command = 'setlocal spell textwidth=72 colorcolumn=51,73'} )
vim.api.nvim_create_autocmd({'Filetype'}, {pattern = 'text', group = plaintext, command = 'setlocal spell foldmethod=marker foldcolumn=2'} )
vim.api.nvim_create_autocmd({'Filetype'}, {pattern = 'markdown', group = markdown, command = 'setlocal spell conceallevel=2'} )
vim.api.nvim_create_autocmd('TextYankPost', {
    group = yank_group,
    pattern = '*',
    callback = function()
        vim.highlight.on_yank({
            higroup = 'IncSearch',
            timeout = 500,
        })
    end,
})