-- ============================================================================
-- Major Maps *major-maps* {{{1
vim.g.mapleader = ' '
vim.g.maplocalleader = ' '

-- }}}1
local silent = { silent = true, noremap = true }

-- Telescope
--local builtin = require('telescope.builtin')
--vim.keymap.set('n', '<leader>ff', builtin.find_files, silent)
--vim.keymap.set('n', '<leader>fg', builtin.live_grep, silent)
--vim.keymap.set('n', '<leader>fb', builtin.buffers, silent)
--vim.keymap.set('n', '<leader>fh', builtin.help_tags, silent)

-- shortcuts to change buffers the same way as tabs
-- vim.keymap.set('n', 'gb', ':bn<CR>', silent)
-- vim.keymap.set('n', 'gB', ':bp<CR>', silent)

vim.api.nvim_set_keymap("n", "<C-h>", ":NvimTreeToggle<cr>", {silent = true, noremap = true})

-- Fast save
vim.keymap.set('n', '<leader>w', ':w!<cr>', silent)

vim.keymap.set('n', '<leader>n', ':NvimTreeToggle<cr>', silent)

vim.keymap.set('n', '<leader><space>', ':noh<cr>', silent)

-- Remap, because % is mapped to matchit
vim.keymap.set({ 'n', 'v' }, '<tab>', '%', { silent = true, remap = true })

vim.keymap.set('n', '<leader>s', ':%s//<left>', silent)
vim.keymap.set('v', '<leader>s', ':s//<left>', silent)

-- use enter/backspace to add/remove lines in normal mode
-- New line without entering insert mode
vim.keymap.set('n', '<CR>', 'o<Esc>k', silent)
vim.keymap.set('n', '<S-CR>', 'ko<Esc>j', silent)
vim.keymap.set('n', '<Backspace>', 'ddk', silent)

-- Do not fill the yank register with single chars
vim.keymap.set('n', 'x', '"_x', silent)
vim.keymap.set('n', 'X', '"_X', silent)

vim.keymap.set("n", "J", "mzJ`z")

vim.keymap.set("v", "J", ":m '>+1<CR>gv=gv")
vim.keymap.set("v", "K", ":m '<-2<CR>gv=gv")

vim.keymap.set('n', '<leader>u', ':UndotreeToggle<CR>', silent)

vim.keymap.set('n', '<A-,>', '<Cmd>BufferPrevious<CR>', silent)
vim.keymap.set('n', '<A-.>', '<Cmd>BufferNext<CR>', silent)

vim.keymap.set('n', '<A-<>', '<Cmd>BufferMovePrevious<CR>', silent)
vim.keymap.set('n', '<A->>', '<Cmd>BufferMoveNext<CR>', silent)

vim.keymap.set('n', '<A-1>', '<Cmd>BufferGoto 1<CR>', silent)
vim.keymap.set('n', '<A-2>', '<Cmd>BufferGoto 2<CR>', silent)
vim.keymap.set('n', '<A-3>', '<Cmd>BufferGoto 3<CR>', silent)
vim.keymap.set('n', '<A-4>', '<Cmd>BufferGoto 4<CR>', silent)
vim.keymap.set('n', '<A-5>', '<Cmd>BufferGoto 5<CR>', silent)
vim.keymap.set('n', '<A-6>', '<Cmd>BufferGoto 6<CR>', silent)
vim.keymap.set('n', '<A-7>', '<Cmd>BufferGoto 7<CR>', silent)
vim.keymap.set('n', '<A-8>', '<Cmd>BufferGoto 8<CR>', silent)
vim.keymap.set('n', '<A-9>', '<Cmd>BufferGoto 9<CR>', silent)
vim.keymap.set('n', '<A-0>', '<Cmd>BufferLast<CR>', silent)

vim.keymap.set('n', '<A-p>', '<Cmd>BufferPin<CR>', silent)

vim.keymap.set('n', '<A-c>', '<Cmd>BufferClose<CR>', silent)
